Como faço para reiniciar o sphinx quando reinicio o servidor Ubuntu?


12

Eu construí e instalei a pesquisa sphinx no meu servidor ubuntu 9.04.

Como faço para que o daemon sphinx inicie automaticamente quando eu reinicio?

Respostas:


13

Não conheço a Sphinx, mas aqui está a abordagem básica. Crie um arquivo /etc/init.d/searchd com o seguinte conteúdo (também existe esse script , mas você provavelmente precisará ajustá-lo um pouco):

#!/bin/bash

case "${1:-''}" in
  'start')
        # put the command to start sphinx
        # i.e., /usr/bin/searchd start or /usr/bin/searchd --daemon or whatever the command is
        ;;
  'stop')
        # stop command here
        ;;
  'restart')
        # restart command here
        ;;
  *)
        echo "Usage: $SELF start|stop|restart"
        exit 1
        ;;
esac

Em seguida, execute o seguinte:

$ sudo update-rc.d searchd defaults

Para controlar o serviço manualmente:

$ sudo /etc/init.d/searchd <start|stop|restart>

Este script funcionou perfeitamente. Para o registro, aqui estão os comandos start / stop / restart que eu usei. Este é um servidor Ubuntu Hardy e eu instalei o sphinx 0.9.8.1-release a partir da fonte. start / usr / local / bin / searchd stop / usr / local / bin / searchd - stop restart / usr / local / bin / searchd --stop && / usr / local / bin / searchd
Apreche

Funcionou como um encanto. Uma palavra de cautela: verifique se o arquivo searchd possui as permissões adequadas.
David

1

Implementamos o Sphinx para um cliente nos sistemas Debian e usamos o Runit para gerenciar os processos. Não tivemos que escrever um script init especial e, como estávamos usando o Runit em outras plataformas (principalmente o CentOS / RHEL), ele era perfeitamente portátil.


1

A versão do sphinx que está empacotada para o ubuntu no momento da escrita (0.99) possui o script de inicialização abaixo.

Eu o reutilizei para a versão 2.0.1 que compilei da fonte, apenas alterando a linha DAEMON=/usr/local/..e funciona para mim.

#! /bin/sh
#
#       Written by Miquel van Smoorenburg <miquels@cistron.nl>.
#       Modified for Debian
#       by Ian Murdock <imurdock@gnu.ai.mit.edu>.
#               Further changes by Javier Fernandez-Sanguino <jfs@debian.org>
#               Modified for sphinx by Radu Spineanu <radu@debian.org>
#
#

### BEGIN INIT INFO
# Provides:          sphinxsearch
# Required-Start:    $local_fs $remote_fs $syslog $network $time
# Required-Stop:     $local_fs $remote_fs $syslog $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Fast standalone full-text SQL search engine
### END INIT INFO


PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/sphinx/bin/searchd
NAME=sphinxsearch
DESC=sphinxsearch

test -x $DAEMON || exit 0

LOGDIR=/var/log/sphinxsearch
PIDFILE=/var/run/searchd.pid
DODTIME=1                   # Time to wait for the server to die, in seconds
                            # If this value is set too low you might not
                            # let some servers to die gracefully and
                            # 'restart' will not work

# Include sphinxsearch defaults if available
if [ -f /etc/default/sphinxsearch ] ; then
    . /etc/default/sphinxsearch
fi

if [ "$START" != "yes" ]; then
  echo "To enable $NAME, edit /etc/default/sphinxsearch and set START=yes"
  exit 0
fi


set -e

running_pid()
{
    # Check if a given process pid's cmdline matches a given name
    pid=$1
    name=$2
    [ -z "$pid" ] && return 1
    [ ! -d /proc/$pid ] &&  return 1
    cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
    # Is this the expected child?
    [ "$cmd" != "$name" ] &&  return 1
    return 0
}

running()
{
# Check if the process is running looking at /proc
# (works for all users)

    # No pidfile, probably no daemon present
    [ ! -f "$PIDFILE" ] && return 1
    # Obtain the pid and check it against the binary name
    pid=`cat $PIDFILE`
    running_pid $pid $DAEMON || return 1
    return 0
}

force_stop() {
# Forcefully kill the process
    [ ! -f "$PIDFILE" ] && return
    if running ; then
        kill -15 $pid
        # Is it really dead?
        [ -n "$DODTIME" ] && sleep "$DODTIME"s
        if running ; then
            kill -9 $pid
            [ -n "$DODTIME" ] && sleep "$DODTIME"s
            if running ; then
                echo "Cannot kill $LABEL (pid=$pid)!"
                exit 1
            fi
        fi
    fi
    rm -f $PIDFILE
    return 0
}

case "$1" in
  start)
        echo -n "Starting $DESC: "

        # Check if we have the configuration file
        if [ ! -f /etc/sphinxsearch/sphinx.conf ]; then
            echo "Please create an /etc/sphinxsearch/sphinx.conf configuration file."
            echo "Templates are in the /etc/sphinxsearch/ directory."
            exit 0
        fi

        start-stop-daemon --start --exec ${DAEMON}
        if running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        echo "$NAME."
        ;;
  force-stop)
        echo -n "Forcefully stopping $DESC: "
        force_stop
        if ! running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  restart)
    echo -n "Restarting $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        [ -n "$DODTIME" ] && sleep $DODTIME
        start-stop-daemon --start --exec ${DAEMON}
        echo "$NAME."
        ;;

  status)
    echo -n "$LABEL is "
    if running ;  then
        echo "running"
    else
        echo " not running."
        exit 1
    fi
    ;;
  *)
    N=/etc/init.d/$NAME
    # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
    echo "Usage: $N {start|stop|restart|force-reload|status|force-stop}" >&2
    exit 1
    ;;
esac

exit 0

Isso também funcionou para mim!
ChrisInCambo

0

Realmente não conheço esfinge, mas, a julgar pelo manual online, você precisa ter um script de inicialização para executar o daemon. Normalmente, isso é feito criando uma entrada no /etc/init.d e vinculando-a ao diretório /etc/rcX.d apropriado. Verifique o arquivo README em /etc/init.d para obter detalhes.

Se nada mais, algo como isto é a resposta rápida e suja:

$ cat > /etc/init.d/sphinx
cd /usr/local/sphinx/etc
/usr/local/sphinx/bin/searchd
^D
$ ln -s /etc/init.d/sphinx /etc/init.d/rc3.d/S99sphinx

0

Crie um arquivo de script curto (bash, talvez) que tenha o equivalente à seguinte linha:

/ caminho / para / sphinx / installation / searchd --config /path/to/sphinx/config/sphinx.conf &

Em seguida, mova o script para /etc/init.d como root e chmod o script ("chmod + x myscript.sh")


0

Adicione um script de reinicialização ao diretório /etc/init.d.


0

Eu sugeriria uma solução ainda mais simples:

Apenas adicione / usr / bin / searchd em /etc/rc.local antes da linha que diz exit 0


0

Se você usar esfinge em seu aplicativo de trilhos, é uma maneira fácil de gerenciar isso com a gema sempre .

Ryan Bates fez um ótimo screencast sobre isso. Este site não me permite colocar mais de um link aqui, mas eu o recomendo.


Ao utilizar nosso site, você reconhece que leu e compreendeu nossa Política de Cookies e nossa Política de Privacidade.
Licensed under cc by-sa 3.0 with attribution required.